<?php
/**
* @version		2.5.0
* @package		AceSEF
* @subpackage	AceSEF
* @copyright	2009-2012 JoomAce LLC, www.joomace.net
* @license		GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/

// No Permission
defined('_JEXEC') or die('Restricted access');

class plgSystemAcesef extends JPlugin {

	static $AcesefConfig;

	function __construct(& $subject, $config) {
		parent::__construct($subject, $config);
		
		if (version_compare(PHP_VERSION, '5.2.0', '>=')) {
			// Get config object
			$factory_file = JPATH_ADMINISTRATOR.'/components/com_acesef/library/factory.php';

			if (file_exists($factory_file)) {
				require_once($factory_file);
				//self::$AcesefConfig = AcesefFactory::getConfig();
				self::$AcesefConfig = AcesefFactory::getConfig();

			}
		}
	}

	function onAfterInitialise() {
		jimport('joomla.language.helper');
		//this is for calling staticly
		if(is_null(self::$AcesefConfig)){
			self::$AcesefConfig = AcesefFactory::getConfig();
		}
		
		if (self::$AcesefConfig->multilang == 1) {
			//JFactory::getApplication()->set('menu_associations', 1);
			AcesefUtility::set('menu_associations', 1);
		}
		
		if (!self::_systemCheckup(false)) {
			return true;
		}
		
		self::_loadLibrary();

		AcesefPlugin::onAfterInitialise();
		
		return true;
	}

    Static function onAfterRoute() {

		if (!self::_systemCheckup()) {
			return true;
		}
		
		self::_loadLibrary();
		
		AcesefPlugin::onAfterRoute();
		
		return true;
    }

    function onAfterDispatch() {
		if (!self::_systemCheckup()) {
			return true;
		}
		
		self::_loadLibrary();
		
		AcesefPlugin::onAfterDispatch();
		
		return true;
    }
	
	function onContentPrepare($context, &$article, &$params = null, $limitstart = 0) {
		if (!self::_systemCheckup()) {
			return true;
		}
		
		self::_loadLibrary();
		
		AcesefPlugin::onContentPrepare($article->text);
		
		return;
	}
    
	function onAfterRender() {
		if (!self::_systemCheckup()) {
			return true;
		}
		
		self::_loadLibrary();
		
		AcesefPlugin::onAfterRender();

		return true;
	}
	
	function onAcesefTags(&$text) {
		if (!self::_systemCheckup()) {
			return;
		}
		
		self::_loadLibrary();
		
		AcesefPlugin::onAcesefTags($text);
		
		return;
	}
	
	function onAcesefIlinks(&$text) {
		if (!self::_systemCheckup()) {
			return;
		}
		
		self::_loadLibrary();
		
		AcesefPlugin::onAcesefIlinks($text);
		
		return;
	}
	
	function onAcesefBookmarks(&$text) {
		if (!self::_systemCheckup()) {
			return;
		}
		
		self::_loadLibrary();
		
		AcesefPlugin::onAcesefBookmarks($text);
		
		return;
	}
	
	Static function _systemCheckup($check_raw = true) {
		if (version_compare(PHP_VERSION, '5.2.0', '<')) {
			JError::raiseWarning('100', JText::sprintf('AceSEF requires PHP 5.2.x to run, please contact your hosting company.'));
			return false;
		}
		
		//this is for calling staticly
		if(is_null(self::$AcesefConfig)){
			self::$AcesefConfig = AcesefFactory::getConfig();
		}
        
		if (strlen(self::$AcesefConfig->download_id) != 32) {
			return false;
		}
		
		// Is backend
		if (JFactory::getApplication()->isAdmin()) {
			return false;
		}

		// Joomla SEF is disabled
		if (!JFactory::getConfig()->get('sef')) {
			return false;
		}

		// Check if AceSEF is enabled
		if (self::$AcesefConfig->mode == 0) {
			return false;
		}
		
		// Is plugin enabled
		if (!JPluginHelper::isEnabled('system', 'acesef')) {
			return false;
		}
		
		$raw = ((JFactory::getApplication()->input->get('format') == 'raw') || (JFactory::getApplication()->input->get('format') == 'xml') || (JFactory::getApplication()->input->get('tmpl') == 'raw'));
		if ($check_raw && $raw) {
			return false;
		}
		
		return true;
	}
	
	static function _loadLibrary() {
		require_once(JPATH_ADMINISTRATOR.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_acesef'.DIRECTORY_SEPARATOR.'library'.DIRECTORY_SEPARATOR.'loader.php');
	}
}
?>